:- use_module(mat).
%Seems to work for column cases now, hand calculate values below, the do the same for Row, then when both are  larger than 1, the do when quota is smaller
%Do check all test cases ad verify that trhe code behaves correct  
%proj 4x4 into 4x4
test(mat_project_into1):-
	mat(M1,[[2,2,1,3],
	        [1,3,1,6],
	        [2,4,1,8],
	        [3,6,5,3]]),
	mat(M2,4,4),
	mat_project_into(M1,M2),
	mat_pp(M2).

%proj 4x4 into 4x2
test(mat_project_into2):-
	mat(M1,[[2,2,1,3],
	        [1,3,1,6],
	        [2,4,1,8],
	        [3,6,5,3]]),
	mat(M2,4,2),
	mat_project_into(M1,M2),
	mat_pp(M2).

%proj 4x5 into 4x2
test(mat_project_into3):-
	mat(M1,[[2,2,2,1,3],
	        [1,3,2,1,6],
	        [2,4,6,1,8],
	        [3,6,9,3,3]]),
	mat(M2,4,2),
	mat_project_into(M1,M2),
	mat_pp(M2).
%proj 4x7 into 4x2
test(mat_project_into4):-
	mat(M1,[[2,2,1,3,4,1,3], 
	        [1,3,1,3,4,1,6],
	        [2,4,1,3,4,1,8],
	        [3,6,1,3,4,5,3]]),
	mat(M2,4,2),
	mat_project_into(M1,M2),
	mat_pp(M2).
%proj 4x7 into 4x3
test(mat_project_into5):-
	mat(M1,[[2,2,1,3,4,1,3], %
	        [1,3,1,3,4,1,6],
	        [2,4,1,3,4,1,8],
	        [3,6,1,3,4,5,3]]),
	mat(M2,4,3),
	mat_project_into(M1,M2),
	mat_pp(M2).

%proj 4x4 into 2x4
test(mat_project_into6):-
	mat(M1,[[2,2,1,3],
	        [1,3,1,6],
	        [2,4,1,8],
	        [3,6,5,3]]),
	mat(M2,2,4),
	mat_project_into(M1,M2),
	mat_pp(M2).
%proj 4x5 into 2x4 
test(mat_project_into7):-
	mat(M1,[[2,4,2,3],
	        [1,3,1,6],
                [3,2,3,6],
		[2,4,1,8],
	        [1,6,5,4]]),
	mat(M2,2,4),
	mat_project_into(M1,M2),
	mat_pp(M2).

%proj 5x5 into 2x2 
test(mat_project_into8):-
	mat(M1,[[1,2,1,1,3],
	        [5,8,1,1,2],
                [4,4,1,4,4],
		[3,4,1,1,7],
	        [3,6,1,5,3]]),
	mat(M2,2,2),trace,
	mat_project_into(M1,M2),
	mat_pp(M2).

%proj 4x5 into 2x3 
test(mat_project_into9):-
	mat(M1,[[2,2,1,3],
	        [1,3,1,6],
                [4,4,4,4],
		[2,4,1,8],
	        [3,6,5,3]]),
	mat(M2,2,3),
	mat_project_into(M1,M2),
	mat_pp(M2).

%proj 1x3 into 1x4 
test(mat_project_into10):-
	mat(M1,[[2,3,2],
		[2,4,5]]),
	mat(M2,2,4),
	mat_project_into(M1,M2),
	mat_pp(M2).

%proj 1x3 into 1x4 
test(mat_project_into11):-
	mat(M1,[[2,3,2],
		[3,1,3],
		[2,4,5]]),
	mat(M2,4,4),
	mat_project_into(M1,M2),
	mat_pp(M2).